#!/bin/bash

# 检查是否提供了文件名作为参数
if [ "$#" -ne 1 ]; then
    echo "Usage: $0 filename"
    exit 1
fi

# 获取输入文件名
filename="$1"

# 使用 awk 处理文件内容
awk '
    BEGIN {
        in_loop_plus=0
        sum=0
        count=0
    }
    /LOOP\+/ {
        in_loop_plus=1
    }
    !in_loop_plus {
        if (/LOOP:/) {
            match($0, /cpu time\s+([0-9.]+)/, arr)
            if (arr[1] != "") {
                sum += arr[1]  # 累加 CPU 时间
                count++         # 计数
            }
        }
    }
    END {
        if (count > 0) {
            avg = sum / count  # 计算平均值
            printf "Average CPU time: %.4f\n", avg
        } else {
            print "No LOOP entries found before LOOP+"
        }
    }
' "$filename"

